<!--反馈体系 created By 1173944134@qq.com-->
<template>
    <!--证书弹窗-->
    <div class="yidialog-con feed-back-dia" id="feedBackDia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-cls-con flex-row">
                <img src="" class="yid-cls"/>
            </div>
            <div class="yid-con-body flex-row">
                <div class="title">恭喜你获得结课证书</div>
                <div class="course-name"></div>
                <img src="" class="cert"/>
                <div class="btn-con scan-cert heart-beat">
                    <img src="" class="btn"/>
                </div>
                <div class="mark">* 证书已添加到APP“我的-证书”列表</div>
            </div>
            <img src="" class="star-l light-forever1"/>
            <img src="" class="star-s light-forever"/>
            <img src="" class="yuan"/>
            <img src="" class="yun rotate-forever"/>
        </div>
    </div>
    <!--toast-->
    <div class="yidialog-con yid-toast-con" id="toastCon">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body flex-row">
                <!--消息-->
                <div class="msg"></div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        /**反馈体系**/
        imgPath: resourcePath + '/imgs/groupPurchase/act/feed_back/',
        data: {
            fullscreen: false, // 是否全屏
            videoPlayer: null, // 播放器
            courseInfo: {} // 课程信息
        },
        pvuvKey: {},
        name: 'feed_back',
        init: function () {
            ApiHelper.sectionList && this.initSectionList()
            ApiHelper.sectionContent && this.initSectionContent()
        },
        // 课程目录页面卡片
        initSectionList: function () {
            var that = this
            ApiHelper.$on('getSectionList', function (e, data) {
                var resData = data || {}
                var allSeasonSectionList = resData.allSeasonSectionList || []
                allSeasonSectionList = allSeasonSectionList[0] || {}
                that.data.courseInfo = allSeasonSectionList.courseInfo || {}
                if (!resData.needPopCourseCertificate) {
                    return
                }
                that.showMyCert()
            })
        },
        isAndroid: function () {
            return navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1
        },
        // 设置已经看过此节课 ApiHelper.$emit('sectionStudied')
        setUserSectionStudied: function () {
            var that = this
            var sectionId = ApiHelper.getQueryString('sectionId')
            var courseId = ApiHelper.getQueryString('courseId')
            $.get('/wx/groupBuy/setUserSectionStudied.json', {
                courseId: courseId,
                sectionId: sectionId
            }, function (res) {
                var resData = res.value || {}
                if (that.data.videoPlayer && resData.needPopCourseCertificate) {
                    try {
                        if (that.isAndroid()) {
                            $('video').css({
                                width: '0px'
                            })
                            // 普通全屏或X5全屏
                            if (!(that.data.videoPlayer.isFullscreen() || that.data.fullscreen)) {
                                that.data.videoPlayer.pause()
                            }
                            that.data.videoPlayer.webkitExitFullscreen()
                            that.data.videoPlayer.exitFullScreen()
                        } else {
                            that.data.videoPlayer.pause()
                            that.data.videoPlayer.exitFullscreen()
                        }
                    } catch (e) {
                    }
                    that.data.videoPlayer.exitFullWindow()
                }
                if (resData.needPopCourseCertificate) {
                    that.showMyCert()
                }
            })
        },
        // 显示证书
        showMyCert: function () {
            var that = this
            if ($('#feedBackDia').length === 0) {
                $(feedBackDia).appendTo($('body'))
                $('#feedBackDia .cert').attr('src', that.imgPath + 'cert.png?v=' + window.groupBuyVersion)
                $('#feedBackDia .star-l').attr('src', that.imgPath + 'star-l.png?v=' + window.groupBuyVersion)
                $('#feedBackDia .star-s').attr('src', that.imgPath + 'star-s.png?v=' + window.groupBuyVersion)
                $('#feedBackDia .yuan').attr('src', that.imgPath + 'yuan.png?v=' + window.groupBuyVersion)
                $('#feedBackDia .yun').attr('src', that.imgPath + 'yun.png?v=' + window.groupBuyVersion)
                $('#feedBackDia .course-name').text(that.data.courseInfo.courseName)
                $('#feedBackDia .yid-cls').attr('src', that.imgPath + 'close_bs.png?v=' + groupBuyVersion)
                $('#feedBackDia .btn').attr('src', that.imgPath + 'see-cert.png?v=' + groupBuyVersion)
                $('#feedBackDia .yid-cls-con').click(function () {
                    $('#feedBackDia').hide()
                    $('video').css({
                        width: '100%'
                    })
                })
                $('#feedBackDia .scan-cert').click(function () {
                    $('#feedBackDia').hide()
                    setTimeout(function () {
                        if (that.isAndroid()) {
                            location.href = 'http://a.app.qq.com/o/simple.jsp?pkgname=com.i61.dengta&ckey=CK1431988224845'
                        } else {
                            location.href = 'itms-apps://itunes.apple.com/app/id1458106216'
                        }
                    }, 100)
                })
            }
            $('#feedBackDia').css({
                display: 'flex'
            })
        },
        // 课程播放页
        initSectionContent: function () {
            var that = this
            that.initSectionList()
            var hasSetSectionStudied = false // 是否已经学过
            // 注册看课事件
            ApiHelper.$on('sectionStudied', function (e, data) {
                var resData = data || {}
                var courseSectionInfo = resData.courseSectionInfo
                var studiedTime = Math.floor(courseSectionInfo.playDuration * 0.9)
                that.data.videoPlayer = resData.videoPlayer

                var v = document.getElementsByTagName('video')[0]
                v.addEventListener('x5videoenterfullscreen', function () {
                    that.data.fullscreen = true
                })
                v.addEventListener('x5videoexitfullscreen', function () {
                    that.data.fullscreen = false
                })
                // 为了全屏下倒数2秒暂停播放看到证书
                var timeInterval = setInterval(function () {
                    var currentTime = that.data.videoPlayer.currentTime;
                    currentTime = typeof currentTime == 'function' ? currentTime.call(that.data.videoPlayer) : currentTime;
                    var last = courseSectionInfo.playDuration - currentTime
                    var display = $('#feedBackDia').css('display')

                    if (last <= 2 && display === 'flex' && (that.data.videoPlayer.isFullscreen() || that.data.fullscreen)) {
                        that.data.videoPlayer.pause()
                        clearInterval(timeInterval)
                    }
                    if (currentTime < studiedTime || hasSetSectionStudied) {
                        return
                    }
                    that.setUserSectionStudied()
                    hasSetSectionStudied = true
                }, 1000)
            })
        }
    }
</script>

<style scoped lang="less">
    .flex-row {
        display: -moz-box;
        /* 老版本语法: Firefox (buggy) */
        display: -ms-flexbox;
        /* 混合版本语法: IE 10 */
        display: -webkit-flex;
        /* 新版本语法: Chrome 21+ */
        display: flex;
    }

    @cl-mask: rgba(0, 0, 0, 0.85);
    /**弹窗**/
    .yidialog-con {
        position: fixed;
        width: 100%;
        height: 100%;
        top: 0px;
        left: 0px;
        display: flex;
        align-items: center;
        justify-content: center;
        z-index: 1000;

        .yid-back {
            position: absolute;
            left: 0px;
            top: 0px;
            width: 100%;
            height: 100%;
            text-align: center;
            background: @cl-mask;
        }

        .yid-con {
            position: relative;
            display: flex;
            justify-content: center;
            align-content: center;
            color: #ffffff;
            flex-wrap: wrap;

            .yid-cls {
                position: relative;
                z-index: 9999;
                width: 0.51rem;
                height: 0.51rem;
                flex-shrink: 0;
            }

            .yid-hand {
                position: absolute;
                width: 1rem;
                top: 3.1rem;
                right: 0.1rem;
                animation: handClick 1s infinite;
            }
        }

        .yid-con-col {
            flex-direction: column;
        }
    }

    /**证书弹窗**/
    .feed-back-dia {
        display: none;

        .yid-con {
            width: 709px;
            height: 770px;
            flex-direction: column;
            flex-wrap: unset;
            justify-content: flex-start;
            position: relative;

            .yid-cls-con {
                width: 709px;
                margin-top: 52px;
                justify-content: flex-end;

                .yid-cls {
                    margin-right: 76px;
                    width: 24px;
                    height: 24px;
                }
            }

            .yid-con-body {
                flex-direction: column;
                align-items: center;

                .title, .course-name {
                    font-size: 34px;
                    color: #ffffff;
                    margin-top: 15px;
                }

                .cert {
                    width: 456px;
                    height: 243px;
                    margin-top: 66px;
                    z-index: 1;
                }

                .scan-cert {
                    width: 293px;
                    height: 93px;
                    margin-top: 152px;
                    z-index: 66;

                    .btn {
                        width: 100%;
                        height: 100%;
                    }
                }

                .mark {
                    margin-top: 29px;
                    font-size: 20px;
                    color: #e6e6e6;
                }
            }

            .star-l, .star-s, .yuan, .yun {
                position: absolute;
                top: 0;
                left: 0;
            }

            .star-l {
                width: 536px;
                height: 391px;
                top: 169px;
                left: 83px;
            }

            .star-s {
                width: 584px;
                height: 388px;
                top: 91px;
                left: 62px;
            }

            .yuan {
                width: 488px;
                height: 488px;
                top: 109px;
                left: 108px;
            }

            .yun {
                width: 706px;
                height: 719px;
                left: 1px;
            }
        }
    }

    /**toast**/
    .yid-toast-con {
        display: none;

        .yid-back {
            opacity: 0;
        }

        .yid-con {
            .yid-con-body {
                justify-content: center;
                align-items: center;

                .msg {
                    padding: 20px;
                    background-color: #333333;
                    color: #ffffff;
                    font-size: 28px;
                    border-radius: 10px;
                }
            }
        }
    }

    /**动画**/

    /**闪烁**/
    .light-forever {
        animation: lightForever 2s linear infinite;
    }

    .light-forever1 {
        opacity: 0;
        animation-duration: 3s;
        animation-name: lightForever;
        animation-iteration-count: infinite;
        animation-delay: 2s;
    }

    @keyframes lightForever {
        from {
            opacity: 0;
            transform: scale(0.99);
        }
        50% {
            opacity: 1;
            transform: scale(1.01);
        }
        100% {
            opacity: 0;
            transform: scale(0.99);
        }
    }

    /**不停旋转*/
    .rotate-forever {
        animation: rotate-forever 4s linear;
        animation-iteration-count: infinite;
        -webkit-animation: rotate-forever 4s linear;
        -webkit-animation-iteration-count: infinite;
    }

    @-webkit-keyframes rotate-forever {
        from {
            transform: rotateZ(0);
            -webkit-transform: rotateZ(0);
        }

        to {
            transform: rotateZ(360deg);
            -webkit-transform: rotateZ(360deg);
        }
    }

    .icon-click {
        animation: iconClick 1s infinite;
    }

    @keyframes iconClick {
        0%, 100% {
            margin-bottotm: 0;
        }
        50% {
            margin-bottom: -35px;
            transform: scale(1.1);
        }
    }

    @keyframes handClick {
        from {
            margin-top: 0rem;
            margin-right: 0rem;
        }
        50% {
            margin-top: -0.1rem;
            margin-right: 0.1rem;
            transform: scale(0.9);
        }
        to {
            margin-top: -0rem;
            margin-right: 0rem;
        }
    }

    .scale-size {
        animation: scaleSize 2s infinite;
    }

    @keyframes scaleSize {
        from {
            transform: scale(0.9);
            opacity: 0.9;
        }
        50% {
            transform: scale(1.2);
            opacity: 1;
        }
        to {
            transform: scale(0.9);
            opacity: 0.9;
        }
    }

    .heart-beat {
        animation: heartBeat 1s infinite;
    }

    @keyframes heartBeat {
        0% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        14% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        28% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        42% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        70% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }
    }

    /**淡入*/
    .fade-in {
        animation: fadeIn 1s;
    }

    @keyframes fadeIn {
        from {
            opacity: 0;
        }
        to {
            opacity: 1;
        }
    }

    /**从上向下淡入*/
    .slide-down {
        animation: slideDown .5s;
    }

    @keyframes slideDown {
        from {
            -webkit-transform: translate3d(0, -100%, 0);
            transform: translate3d(0, -100%, 0);
            visibility: visible;
            opacity: 0;
        }
        to {
            -webkit-transform: translate3d(0, 0, 0);
            transform: translate3d(0, 0, 0);
            opacity: 1;
        }
    }

    /**从上向下淡出*/
    .slide-down-out {
        animation: slideDownOut 1s;
    }

    @keyframes slideDownOut {
        from {
            -webkit-transform: translate3d(0, 0, 0);
            transform: translate3d(0, 0, 0);
            visibility: visible;
            opacity: 1;
        }
        to {
            -webkit-transform: translate3d(0, 100%, 0);
            transform: translate3d(0, 100%, 0);
            opacity: 0;
        }
    }
</style>
